// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/api/intime/os_msg.c $
// $Rev: 43206 $
// $Date: 2018-07-08 17:03:14 -0500 (Sun, 08 Jul 2018) $

// INtime: API Library: source file

#include "main.h"




//*****************************************************************************
// Return Values:
//	0  = success
//	<0 = failure, value is -errno or -INtime error code
//	>0 = never returned
int os_msg_alloc(os_msg_t** msg)
{
	os_msg_t*	ptr;
	int			ret;

	for (;;)	// A convenience loop.
	{
		if (msg == NULL)
		{
			ret	= -EINVAL;
			break;
		}

		ptr	= malloc(sizeof(os_msg_t));

		if (ptr == NULL)
		{
			msg[0]	= NULL;
			ret		= -ENOMEM;
			break;
		}

		memset(ptr, 0, sizeof(os_msg_t));
		msg[0]	= ptr;
		ret		= 0;
		break;
	}

	return(ret);
}



//*****************************************************************************
// Return Values:
//	0  = success
//	<0 = failure, value is -errno or -INtime error code
//	>0 = never returned
int os_msg_free(os_msg_t** msg)
{
	int	ret;

	for (;;)	// A convenience loop.
	{
		if (msg == NULL)
		{
			// There is nothing to.
			ret	= 0;
			break;
		}

		if (msg[0] == NULL)
		{
			// There is nothing to do.
			ret	= 0;
			break;
		}

		memset(msg[0], 0, sizeof(os_msg_t));
		free(msg[0]);
		msg[0]	= NULL;
		ret		= 0;
		break;
	}

	return(ret);
}


