@echo off
rem $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/utils/windows/mvs15/_bmake.bat $
rem $Rev: 42982 $
rem $Date: 2018-06-22 17:12:43 -0500 (Fri, 22 Jun 2018) $

rem MVS 2015: batch file for buiding MVS 2015 targets



rem ===========================================================================
SETLOCAL

set _DEVENV="%VS140COMNTOOLS%..\devenv.exe"

if not exist %_DEVENV%	set _DEVENV="C:\Program Files\Microsoft Visual Studio 14.0\Common7\IDE\devenv.exe"

if not exist %_DEVENV%	set _DEVENV="C:\Program Files (x86)\Microsoft Visual Studio 14.0\Common7\IDE\devenv.exe"

if not exist %_DEVENV%	echo ==== SKIPPING: Visual Studio 2015 Not installed
if not exist %_DEVENV%	goto end



rem ===========================================================================
rem 1 = dir name
rem 2 = user specified build argument
rem 3 = solution file
rem 4 = configuration
rem 5 = first target file
rem 6 = and so on

set	SOLUTION=%3
set	CONFIG=%4

if "%1" == ""		goto error
if "%2" == ""		goto error
if "%3" == ""		goto error
if .%4. == ..		goto error
if "%5" == ""		goto error

if not exist "%3"	goto solution

if "%2" == "clean"	goto clean
if "%2" == "status"	goto status



rem ===========================================================================

if not	"%DEVICE%" == ""	echo ==== %DEVICE%: %1: mvs15: %CONFIG% ====
if		"%DEVICE%" == ""	echo ==== %1: mvs15: %CONFIG% ====

call %_DEVENV% %3 /Build %CONFIG%

goto status



rem ===========================================================================
:clean
echo ==== CLEANING: %CONFIG%: %5 %6 %7 %8 %9

rem call %_DEVENV% %3 /Clean %CONFIG%

if exist .vs				rd /S /Q .vs
if exist Debug				rd /S /Q Debug
if exist Release			rd /S /Q Release
if exist x64				rd /S /Q x64

if exist *.db				del *.db
if exist *.dll				del *.dll
if exist *.htm				del *.htm
if exist *.ncb				del *.ncb
if exist *.sdf				del *.sdf
if exist *.suo				attrib -r -h *.suo
if exist *.suo				del *.suo
if exist log.txt			del log.txt
if exist *.user				del *.user

:clean_more
if exist "%5"		del "%5"
shift
if not "%5" == "" goto clean_more

goto end



rem ===========================================================================
:status

if		exist %5 echo SUCCESS: %5
if not	exist %5 echo FAILURE: %5 ^<-----
shift
if not "%5" == "" goto status
goto end



rem ===========================================================================
:error
echo ERROR:  Command line is invalid.
echo USAGE:  %0 ^<dir name^> ^<user arg^> ^<solution file^> ^<configuration^> ^<1st target^> ^<targets ...^>
echo ACTUAL: %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
goto end



rem ===========================================================================
:solution
echo ERROR: Command line is invalid.
echo ERROR: %0
echo ERROR: Solution file not found: "%3"
goto end



rem ===========================================================================
:end
:end

ENDLOCAL

