// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO4MF/16AO4MF_Linux_2.x.x.x_GSC_DN/driver/16ao4mf.h $
// $Rev: 43266 $
// $Date: 2018-07-09 17:21:40 -0500 (Mon, 09 Jul 2018) $

// 16AO4MF: Device Driver: header file

#ifndef __16AO4MF_H__
#define __16AO4MF_H__

#include "gsc_common.h"
#include "gsc_pci9080.h"



// #defines *******************************************************************

#define AO4MF_BASE_NAME						"16ao4mf"

// IOCTL command codes
#define AO4MF_IOCTL_REG_READ				OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define AO4MF_IOCTL_REG_WRITE				OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define AO4MF_IOCTL_REG_MOD					OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define AO4MF_IOCTL_QUERY					OS_IOCTL_RW( 3,  4, s32)
#define AO4MF_IOCTL_INITIALIZE				OS_IOCTL   ( 4)
#define AO4MF_IOCTL_AUTO_CAL				OS_IOCTL   ( 5)
#define AO4MF_IOCTL_AUTO_CAL_STS			OS_IOCTL_R ( 6,  4, s32)
#define AO4MF_IOCTL_AO_BUF_CLEAR			OS_IOCTL   ( 7)
#define AO4MF_IOCTL_AO_BUF_LOAD_READY		OS_IOCTL_R ( 8,  4, s32)
#define AO4MF_IOCTL_AO_BUF_LOAD_REQ			OS_IOCTL   ( 9)
#define AO4MF_IOCTL_AO_BUF_MODE				OS_IOCTL_RW(10,  4, s32)
#define AO4MF_IOCTL_AO_BUF_SIZE				OS_IOCTL_RW(11,  4, s32)
#define AO4MF_IOCTL_AO_BUF_STATUS			OS_IOCTL_R (12,  4, s32)
#define AO4MF_IOCTL_AO_CLK_ENABLE			OS_IOCTL_RW(13,  4, s32)
#define AO4MF_IOCTL_AO_CLK_SRC				OS_IOCTL_RW(14,  4, s32)
#define AO4MF_IOCTL_AO_EXT_CLKING_READY		OS_IOCTL_R (15,  4, s32)
#define AO4MF_IOCTL_AO_SW_CLK				OS_IOCTL   (16)
#define AO4MF_IOCTL_BURST_MODE				OS_IOCTL_RW(17,  4, s32)
#define AO4MF_IOCTL_BURST_READY				OS_IOCTL_R (18,  4, s32)
#define AO4MF_IOCTL_BURST_TRIGGER			OS_IOCTL   (19)
#define AO4MF_IOCTL_DATA_FORMAT				OS_IOCTL_RW(20,  4, s32)
#define AO4MF_IOCTL_DIO_DIR					OS_IOCTL_RW(21,  4, s32)
#define AO4MF_IOCTL_DIO_RX					OS_IOCTL_R (22,  4, s32)
#define AO4MF_IOCTL_DIO_TX					OS_IOCTL_RW(23,  4, s32)
#define AO4MF_IOCTL_FREF_CLK_SRC			OS_IOCTL_RW(24,  4, s32)
#define AO4MF_IOCTL_INT_SAMP_RATE			OS_IOCTL_RW(25,  4, s32)
#define AO4MF_IOCTL_IRQ_SEL					OS_IOCTL_RW(26,  4, s32)
#define AO4MF_IOCTL_NCLK					OS_IOCTL_RW(27,  4, s32)
#define AO4MF_IOCTL_NRATE					OS_IOCTL_RW(28,  4, s32)
#define AO4MF_IOCTL_RATE_GEN_SEL			OS_IOCTL_RW(29,  4, s32)
#define AO4MF_IOCTL_TX_IO_ABORT				OS_IOCTL_R (30,  4, s32)
#define AO4MF_IOCTL_TX_IO_MODE				OS_IOCTL_RW(31,  4, s32)
#define AO4MF_IOCTL_TX_IO_TIMEOUT			OS_IOCTL_RW(32,  4, s32)
#define AO4MF_IOCTL_XCVR_IN					OS_IOCTL_RW(33,  4, s32)
#define AO4MF_IOCTL_WAIT_EVENT				OS_IOCTL_RW(34, 28, gsc_wait_t)
#define AO4MF_IOCTL_WAIT_CANCEL				OS_IOCTL_RW(35, 28, gsc_wait_t)
#define AO4MF_IOCTL_WAIT_STATUS				OS_IOCTL_RW(36, 28, gsc_wait_t)

//*****************************************************************************
// AO4MF_IOCTL_REG_READ
// AO4MF_IOCTL_REG_WRITE
// AO4MF_IOCTL_REG_MOD
//
#define AO4MF_REG_ENCODE(s,o)				GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define AO4MF_GSC_BCR						AO4MF_REG_ENCODE(4,0x00)// Board Control Register
#define AO4MF_GSC_DIOPCR					AO4MF_REG_ENCODE(4,0x04)// Digital I/O Port Control Register
#define AO4MF_GSC_SRCR						AO4MF_REG_ENCODE(4,0x08)// Sample Rate Control Register
#define AO4MF_GSC_BOR						AO4MF_REG_ENCODE(4,0x0C)// Buffer Operations Register
#define AO4MF_GSC_FRR						AO4MF_REG_ENCODE(4,0x10)// Firmware Revision Register
#define AO4MF_GSC_ADR						AO4MF_REG_ENCODE(4,0x14)// Autocal Diagnostics Register
#define AO4MF_GSC_ODBR						AO4MF_REG_ENCODE(4,0x18)// Output Data Buffer Register
#define AO4MF_GSC_ACCR						AO4MF_REG_ENCODE(4,0x1C)// Adjustable Clock Control Register
#define AO4MF_GSC_ICSCR						AO4MF_REG_ENCODE(4,0x20)// Internal Clock Source Control Register

//*****************************************************************************
// AO4MF_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.
//		The value -1 is returned if the specified option is not supported.

typedef enum
{
	AO4MF_QUERY_COUNT,				// First: The number of query options.
	AO4MF_QUERY_AUT_CAL_MS,			// Max auto-calibration period in ms.
	AO4MF_QUERY_CHANNEL_QTY,		// For the entire board.
	AO4MF_QUERY_DEVICE_TYPE,		// gsc_dev_type_t
	AO4MF_QUERY_FREF_ADJ,			// The adjustable reference frequency.
	AO4MF_QUERY_FREF_MASTER,		// The master reference frequency.
	AO4MF_QUERY_FSAMP_MAX,			// Maximum sample rate.
	AO4MF_QUERY_FSAMP_MIN,			// Minimum sample rate.
	AO4MF_QUERY_INDEX_CHANNEL,		// 0-3
	AO4MF_QUERY_INDEX_DEVICE,		// /dev/16ao4mf.X: 0, 1, 2, 3, 4, 5 ...
	AO4MF_QUERY_INIT_MS,			// Max initialization period in ms.
	AO4MF_QUERY_NCLK_MAX,			// Maximum Nclk value.
	AO4MF_QUERY_NCLK_MIN,			// Minimum Nclk value.
	AO4MF_QUERY_NRATE_MAX,			// Maximum Nrate value.
	AO4MF_QUERY_NRATE_MIN,			// Minimum Nrate value.
	AO4MF_QUERY_REG_DIOPCR,			// Digital I/O Port Control Register: Supported?
	AO4MF_QUERY_SYNC_CLK_OUT,		// Are SYNC OUT and CLK OUT supported?
	AO4MF_IOCTL_QUERY_LAST			// MUST BE LAST!
} ao4mf_query_t;

//*****************************************************************************
// AO4MF_IOCTL_INITIALIZE					BCR D15
//
//	Parameter:	None

//*****************************************************************************
// AO4MF_IOCTL_AUTO_CAL						BCR D12-D13
//
//	Parameter:	None.

//*****************************************************************************
// AO4MF_IOCTL_AUTO_CAL_STS					BCR D14, D12-D13
//
//	Parameter:	s32*
//		One of the following values is returned.
#define AO4MF_AUTO_CAL_STS_ACTIVE			0
#define AO4MF_AUTO_CAL_STS_FAIL				1
#define AO4MF_AUTO_CAL_STS_PASS				2

//*****************************************************************************
// AO4MF_IOCTL_AO_BUF_CLEAR					BOR D11
//
//	Parameter:	None

//*****************************************************************************
// AO4MF_IOCTL_AO_BUF_LOAD_READY			BOR D10
//
//	Parameter:	s32*
//		One of the following values is returned.
#define AO4MF_AO_BUF_LOAD_READY_NO			0
#define AO4MF_AO_BUF_LOAD_READY_YES			1

//*****************************************************************************
// AO4MF_IOCTL_AO_BUF_LOAD_REQ				BOR D9
//
//	Parameter:	None

//*****************************************************************************
// AO4MF_IOCTL_AO_BUF_MODE					BOR D8
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define AO4MF_AO_BUF_MODE_OPEN				0
#define AO4MF_AO_BUF_MODE_CIRC				1

//*****************************************************************************
// AO4MF_IOCTL_AO_BUF_SIZE					BOR D0-D3
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define AO4MF_AO_BUF_SIZE_4					0
#define AO4MF_AO_BUF_SIZE_8					1
#define AO4MF_AO_BUF_SIZE_16				2
#define AO4MF_AO_BUF_SIZE_32				3
#define AO4MF_AO_BUF_SIZE_64				4
#define AO4MF_AO_BUF_SIZE_128				5
#define AO4MF_AO_BUF_SIZE_256				6
#define AO4MF_AO_BUF_SIZE_512				7
#define AO4MF_AO_BUF_SIZE_1K				8
#define AO4MF_AO_BUF_SIZE_2K				9
#define AO4MF_AO_BUF_SIZE_4K				10
#define AO4MF_AO_BUF_SIZE_8K				11
#define AO4MF_AO_BUF_SIZE_16K				12
#define AO4MF_AO_BUF_SIZE_32K				13

//*****************************************************************************
// AO4MF_IOCTL_AO_BUF_STATUS				BOR D12-D15
//
//	Parameter:	s32*
//		One of the following values is returned.
#define AO4MF_AO_BUF_STATUS_EMPTY			0
#define AO4MF_AO_BUF_STATUS_1Q_FULL			1
#define AO4MF_AO_BUF_STATUS_MEDIUM			2
#define AO4MF_AO_BUF_STATUS_3Q_FULL			3
#define AO4MF_AO_BUF_STATUS_FULL			4

//*****************************************************************************
// AO4MF_IOCTL_AO_CLK_ENABLE				BOR D5
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define AO4MF_AO_CLK_ENABLE_NO				0
#define AO4MF_AO_CLK_ENABLE_YES				1

//*****************************************************************************
// AO4MF_IOCTL_AO_CLK_SRC					BOR D4
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define AO4MF_AO_CLK_SRC_INT				0
#define AO4MF_AO_CLK_SRC_EXT_SW				1

//*****************************************************************************
// AO4MF_IOCTL_AO_EXT_CLKING_READY			BOR D6
//
//	Parameter:	s32*
//		One of the following values is returned.
#define AO4MF_AO_EXT_CLKING_READY_NO		0
#define AO4MF_AO_EXT_CLKING_READY_YES		1

//*****************************************************************************
// AO4MF_IOCTL_AO_SW_CLK					BOR D7
//
//	Parameter:	None

//*****************************************************************************
// AO4MF_IOCTL_BURST_MODE					BCR D0
//
//	Parameter:	s32*
//		Pass in any value from the below list,
//		or -1 to read the current setting.
#define AO4MF_BURST_MODE_DISABLE			0
#define AO4MF_BURST_MODE_ENABLE				1

//*****************************************************************************
// AO4MF_IOCTL_BURST_READY					BCR D1
//
//	Parameter:	s32*
//		One of the following values is returned.
#define AO4MF_BURST_READY_NO				0
#define AO4MF_BURST_READY_YES				1

//*****************************************************************************
// AO4MF_IOCTL_BURST_TRIGGER				BCR D2
//
//	Parameter:	None

//*****************************************************************************
// AO4MF_IOCTL_DATA_FORMAT					BCR D4
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define AO4MF_DATA_FORMAT_2S_COMP			0	// Twos Compliment
#define AO4MF_DATA_FORMAT_OFF_BIN			1	// Offset Binary

//*****************************************************************************
// AO4MF_IOCTL_DIO_DIR						DIOPCR D8
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
//		The value -1 is returned if the feature is unsupported.
#define AO4MF_DIO_DIR_IN					0
#define AO4MF_DIO_DIR_OUT					1

//*****************************************************************************
// AO4MF_IOCTL_DIO_RX						DIOPCR D0-D7
//
//	Parameter:	s32*
//		The value returned is from 0 to 0xFF.
//		The value -1 is returned if the feature is unsupported.

//*****************************************************************************
// AO4MF_IOCTL_DIO_TX						DIOPCR D0-D7
//
//	Parameter:	s32*
//		Pass in any value from 0 to 0xFF.
//		The value -1 is returned if the feature is unsupported.

//*****************************************************************************
// AO4MF_IOCTL_FREF_CLK_SRC					ACCR D9
//
//	Parameter:	s32*
//		One of the following values is returned.
#define AO4MF_FREF_CLK_SRC_MASTER			0
#define AO4MF_FREF_CLK_SRC_ADJ				1

//*****************************************************************************
// AO4MF_IOCTL_INT_SAMP_RATE				ICSCR D0-D3
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define AO4MF_INT_SAMP_RATE_VAR				0
#define AO4MF_INT_SAMP_RATE_224000_SPS		1
#define AO4MF_INT_SAMP_RATE_60000_SPS		2
#define AO4MF_INT_SAMP_RATE_27304_SPS		3
#define AO4MF_INT_SAMP_RATE_22500_SPS		4
#define AO4MF_INT_SAMP_RATE_10000_SPS		5

//*****************************************************************************
// AO4MF_IOCTL_IRQ_SEL						BCR D8-D10
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define AO4MF_IRQ_SEL_NONE_INIT_DONE		0
#define AO4MF_IRQ_SEL_AUTO_CAL_DONE			1
#define AO4MF_IRQ_SEL_AO_BUF_EMPTY			2
#define AO4MF_IRQ_SEL_AO_BUF_1Q_FULL		3
#define AO4MF_IRQ_SEL_AO_BUF_3Q_FULL		4
#define AO4MF_IRQ_SEL_BURST_TRIG_READY		5
#define AO4MF_IRQ_SEL_LOAD_READY			6
#define AO4MF_IRQ_SEL_LOAD_READY_END		7

//*****************************************************************************
// AO4MF_IOCTL_NCLK							ACCR D0-D8
//
//	Parameter:	s32*
//		Pass in any value from 0 to 511, or
//		-1 to read the current setting.

//*****************************************************************************
// AO4MF_IOCTL_NRATE						SRCR D0-D15
//
//	Parameter:	s32*
//		Pass in any value from 68 to 0xFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AO4MF_IOCTL_RATE_GEN_SEL					BCR D7
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define AO4MF_RATE_GEN_SEL_CH_0				0
#define AO4MF_RATE_GEN_SEL_CH_ALT			1

//*****************************************************************************
// AO4MF_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		One of the following values is returned.
#define AO4MF_IO_ABORT_NO					0	// An abort did NOT occur.
#define AO4MF_IO_ABORT_YES					1	// An abort DID occur.

//*****************************************************************************
// AO4MF_IOCTL_TX_IO_MODE
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
// GSC_IO_MODE_PIO
// GSC_IO_MODE_DMA
#define AO4MF_IO_MODE_DEFAULT				GSC_IO_MODE_PIO

//*****************************************************************************
// AO4MF_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define AO4MF_IO_TIMEOUT_DEFAULT			10
#define AO4MF_IO_TIMEOUT_NO_SLEEP			0
#define AO4MF_IO_TIMEOUT_MIN				0
#define AO4MF_IO_TIMEOUT_MAX				GSC_IO_TIMEOUT_MAX
#define AO4MF_IO_TIMEOUT_INFINITE			GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// AO4MF_IOCTL_XCVR_IN						BCR D5
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define AO4MF_XCVR_IN_LVDS					0
#define AO4MF_XCVR_IN_TTL					1

//*****************************************************************************
// AO4MF_IOCTL_WAIT_EVENT					all fields must be valid
// AO4MF_IOCTL_WAIT_CANCEL					fields need not be valid
// AO4MF_IOCTL_WAIT_STATUS					fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc

#define AO4MF_WAIT_GSC_INIT_DONE			0x0001
#define AO4MF_WAIT_GSC_AUTO_CAL_DONE		0x0002
#define AO4MF_WAIT_GSC_AO_BUF_EMPTY			0x0004
#define AO4MF_WAIT_GSC_AO_BUF_1Q_FULL		0x0008
#define AO4MF_WAIT_GSC_AO_BUF_3Q_FULL		0x0010
#define AO4MF_WAIT_GSC_BURST_TRIG_READY		0x0020
#define AO4MF_WAIT_GSC_LOAD_READY			0x0040
#define AO4MF_WAIT_GSC_LOAD_READY_END		0x0080
#define AO4MF_WAIT_GSC_ALL					0x00FF
// gsc_wait_t.alt flags
#define AO4MF_WAIT_ALT_ALL					0x0000
// gsc_wait_t.io - see gsc_common.h



#endif
