// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_close.c $
// $Rev: 43205 $
// $Date: 2018-07-08 17:01:59 -0500 (Sun, 08 Jul 2018) $

// INtime: Device Driver: source file

#include "main.h"



//*****************************************************************************
// Return:
//	0	Success
//	< 0	Failure: value is -errno or -GetLastRtError()
//	> 0	Never returned
int os_close(GSC_ALT_STRUCT_T* alt)
{
	int	ret;
	int	tmp;

	for (;;)	// A convenience loop.
	{
		if (alt == NULL)
		{
			// The referenced device doesn't exist.
			ret	= -ENODEV;
			db_printf("%s: Internal error: %s, %d\n", DEV_NAME, __FILE__, __LINE__);
			break;
		}

		ret	= os_sem_lock(&gsc_global.sem);

		if (ret < 0)
		{
			db_printf("%s: os_close(): Failed to acquire master device lock.\n", DEV_NAME);
			break;
		}

		ret	= gsc_close(alt);

		if (ret)
			db_printf("%s: Failed generic closure.\n", DEV_NAME);

		tmp	= os_sem_unlock(&gsc_global.sem);

		if (tmp)
			db_printf("%s: Failed to unlock global semaphore.\n", DEV_NAME);

		break;
	}

	return(ret);
}


