// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_event.c $
// $Rev: 43205 $
// $Date: 2018-07-08 17:01:59 -0500 (Sun, 08 Jul 2018) $

// INtime: Device Driver: source file

#include "main.h"



//*****************************************************************************
void os_event_create(os_event_t* evnt)
{
	if (evnt)
	{
		memset(evnt, 0, sizeof(os_event_t));

		// Create a new, one unit semaphore.
		evnt->handle	= knCreateRtSemaphore((KNPTR) &evnt->sem_data, KN_FIFO_QUEUING | KN_ZERO_UNITS);
	}
}



//*****************************************************************************
void os_event_destroy(os_event_t* evnt)
{
	if (evnt)
	{
		if (evnt->handle != 0xFFFFFFFF)
			knDeleteRtSemaphore(evnt->handle);

		memset(evnt, 0, sizeof(os_event_t));
		evnt->handle	= 0xFFFFFFFF;
	}
}



//*****************************************************************************
void os_event_resume(os_event_t* evnt)
{
	if (evnt)
	{
		if (evnt->handle != 0xFFFFFFFF)
			knReleaseRtSemaphore(evnt->handle);
	}
}



//*****************************************************************************
void os_event_wait(os_event_t* evnt, os_time_tick_t timeout)
{
	if (evnt)
	{
		// Gain access to the semaphore.

		if (evnt->handle != 0xFFFFFFFF)
			knWaitForRtSemaphore(evnt->handle, (DWORD) timeout);
	}
}


