// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_ioctl.c $
// $Rev: 43205 $
// $Date: 2018-07-08 17:01:59 -0500 (Sun, 08 Jul 2018) $

// INtime: Device Driver: source file

#include "main.h"



//*****************************************************************************
// Return:
//	0	Success
//	< 0	Failure: value is -errno or -GetLastRtError()
//	> 0	Never returned
int os_ioctl(GSC_ALT_STRUCT_T* alt, long cmd, void* arg)
{
	int	ret;

	if (alt == NULL)
	{
		ret	= -EFAULT;
		db_printf("%s: Internal failure: %s, %d\n", DEV_NAME, __FILE__, __LINE__);
	}
	else
	{
		ret	= gsc_ioctl(alt, cmd, arg);

		if (ret)
			db_printf("%s: Failed IOCTL processing.\n", DEV_NAME);
	}

	return(ret);
}



//*****************************************************************************
// Return:
//	0	Success
//	< 0	Failure: value is -errno or -GetLastRtError()
//	> 0	Never returned
int os_ioctl_init(void)
{
	// There is nothing to do here.
	return(0);
}



//*****************************************************************************
void os_ioctl_reset(void)
{
	// There is nothing to do here.
}


