// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_open.c $
// $Rev: 43205 $
// $Date: 2018-07-08 17:01:59 -0500 (Sun, 08 Jul 2018) $

// INtime: Device Driver: source file

#include "main.h"



//*****************************************************************************
// Return:
//	0	Success
//	< 0	Failure: value is -errno or -GetLastRtError()
//	> 0	Never returned
int os_open(GSC_ALT_STRUCT_T* alt, int share)
{
	int	ret;
	int	tmp;

	for (;;)	// A convenience loop.
	{
		if (alt == NULL)
		{
			// The pointer is NULL.
			ret	= -EINVAL;
			db_printf("%s: Internal error: %s, %d\n", DEV_NAME, __FILE__, __LINE__);
			break;
		}

		ret	= os_sem_lock(&gsc_global.sem);

		if (ret < 0)
		{
			db_printf("%s: Failed to acquire master device lock.\n", DEV_NAME);
			break;
		}

		ret	= gsc_open(alt, share);

		if (ret)
		{
			db_printf("%s: Failed generic open.\n", DEV_NAME);
			tmp	= gsc_close(alt);

			if (tmp)
				db_printf("%s: Failed generic close.\n", DEV_NAME);
		}

		tmp	= os_sem_unlock(&gsc_global.sem);

		if (tmp)
			db_printf("%s: Failed to release global semaphore.\n", DEV_NAME);

		break;
	}

	return(ret);
}



