// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_utils.c $
// $Rev: 43205 $
// $Date: 2018-07-08 17:01:59 -0500 (Sun, 08 Jul 2018) $

// INtime: Device Driver: source file

#include "main.h"



//*****************************************************************************
int db_printf(const char *format, ...)
{
	va_list args;
	int		qty		= 0;

	if (gsc_global.verbose)
	{
		va_start(args, format);
		qty	= vprintf(format, args);
		va_end(args);
	}

	return(qty);
}



//*****************************************************************************
// Return Values:
//	0  = success
//	<0 = failure, value is -errno or -INtime error code
// WARNING: THIS FUNCTION CANNOT BE CALLED FROM THE ISR!
int os_get_error_status(void)
{
	DWORD	dw;
	int		ret;
	
	dw	= GetLastRtError();
	db_printf("%s: GetLastRtError() => 0x%04lX\n", DEV_NAME, (long) dw);

	ret	= -(int)(dw + INTIME_ERROR_OFFSET);
	return(ret);
}



//*****************************************************************************
int os_get_root_process(RTHANDLE* handle)
{
	int			ret;
	RTHANDLE	root;

	root	= GetRtThreadHandles(ROOT_PROCESS);

	if (root == BAD_RTHANDLE)
	{
		ret	= os_get_error_status();
		db_printf("%s: Failed to get root process handle.", DEV_NAME);
	}
	else
	{
		ret	= 0;

		if (handle)
			handle[0]	= root;
	}

	return(ret);
}


