// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO4MF/16AO4MF_Linux_2.x.x.x_GSC_DN/samples/fsamp/fsamp.c $
// $Rev: 43282 $
// $Date: 2018-07-09 17:42:02 -0500 (Mon, 09 Jul 2018) $

// 16AO4MF: Sample Application: source file

#include "main.h"



// #defines *******************************************************************

#define FILE_NAME				"fsamp.txt"



/******************************************************************************
*
*	Function:	fsamp_compute
*
*	Purpose:
*
*		Configure the board, then capture data.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*		fsamp	The desired rate, if "range" is zero.
*
*		range	Compute the rate for the entire range of supported rates.
*
*		save	Save the range data to fsamp.txt?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int fsamp_compute(int fd, s32 fsamp, int range, int save)
{
	s32		adj;
	int		errs	= 0;
	FILE*	file	= NULL;
	s32		irate;
	s32		max		= 0;
	s32		min		= 0;
	s32		nclk;
	s32		nrate;
	double	rate;
	s32		tmp;

	gsc_label("Fsamp Computation");
	printf("\n");
	gsc_label_level_inc();

	if (range == 0)
	{
		min		= fsamp;
		max		= fsamp;
	}
	else
	{
		errs	+= ao4mf_query(fd, -1, 0, AO4MF_QUERY_FSAMP_MAX, &max);
		errs	+= ao4mf_query(fd, -1, 0, AO4MF_QUERY_FSAMP_MIN, &min);
	}

	if (save)
	{
		file	= fopen(FILE_NAME, "w+b");

		if (file == NULL)
		{
			printf("FAIL <---  (unable to create %s)\n", FILE_NAME);
			errs	= 1;
		}
		else
		{
			fprintf(file, "# 16AO4MF Scan Rates\n");
			fprintf(file, "# Request   Produced\n");
			fprintf(file, "# ========  ==========\n");
		}
	}

	for (fsamp = min; fsamp <= max; fsamp++)
	{
		tmp		= fsamp;
		errs	+= ao4mf_fsamp_compute(fd, -1, 1, tmp, &irate, &nrate, &adj, &nclk, &rate);

		if (file)
			fprintf(file, "%10ld  %10.3f\n", (long) fsamp, (float) rate);
	}

	if (file)
		fclose(file);

	gsc_label_level_dec();
	return(errs);
}


